Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor.cpp	(revision 48)
@@ -6,10 +6,14 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Meta_Predictor.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Meta_Predictor.h"
 
 namespace morpheo                    {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -23,5 +27,5 @@
 			      morpheo::behavioural::Parameters_Statistics             param_statistics,
 #endif
-			      morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::Parameters param ):
+			      morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::Parameters param ):
 			      _name              (name)
 			      ,_param            (param)
@@ -81,6 +85,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_allocation.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_allocation.cpp	(revision 48)
@@ -7,10 +7,14 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Meta_Predictor.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Meta_Predictor.h"
 
 namespace morpheo                    {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -104,5 +108,5 @@
     log_printf(INFO,Meta_Predictor,"allocation","Allocation : %s",name_component.c_str());
     
-    component_Meta_Predictor_Glue = new morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::meta_predictor_glue::Meta_Predictor_Glue (name_component.c_str()               ,
+    component_Meta_Predictor_Glue = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::meta_predictor_glue::Meta_Predictor_Glue (name_component.c_str()               ,
 #ifdef STATISTICS	
 																		   _param_statistics                    ,
@@ -127,5 +131,5 @@
     log_printf(INFO,Meta_Predictor,"allocation","Allocation : %s",name_component.c_str());
     
-    component_Two_Level_Branch_Predictor_2 = new morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::two_level_branch_predictor ::Two_Level_Branch_Predictor (name_component.c_str()               ,
+    component_Two_Level_Branch_Predictor_2 = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::two_level_branch_predictor ::Two_Level_Branch_Predictor (name_component.c_str()               ,
 #ifdef STATISTICS	
 																					   _param_statistics                    ,
@@ -153,5 +157,5 @@
     log_printf(INFO,Meta_Predictor,"allocation","Allocation : %s",name_component.c_str());
     
-    component_Two_Level_Branch_Predictor_1 = new morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::two_level_branch_predictor ::Two_Level_Branch_Predictor (name_component.c_str()               ,
+    component_Two_Level_Branch_Predictor_1 = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::two_level_branch_predictor ::Two_Level_Branch_Predictor (name_component.c_str()               ,
 #ifdef STATISTICS	
 																					   _param_statistics                    ,
@@ -174,5 +178,5 @@
     log_printf(INFO,Meta_Predictor,"allocation","Allocation : %s",name_component.c_str());
     
-    component_Two_Level_Branch_Predictor_0 = new morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::two_level_branch_predictor ::Two_Level_Branch_Predictor (name_component.c_str()               ,
+    component_Two_Level_Branch_Predictor_0 = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::two_level_branch_predictor ::Two_Level_Branch_Predictor (name_component.c_str()               ,
 #ifdef STATISTICS	
 																					   _param_statistics                    ,
@@ -431,6 +435,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 }; // end namespace behavioural
 }; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_deallocation.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_deallocation.cpp	(revision 48)
@@ -7,10 +7,14 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Meta_Predictor.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Meta_Predictor.h"
 
 namespace morpheo                    {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -49,6 +53,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_statistics.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_statistics.cpp	(revision 48)
@@ -7,10 +7,14 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Meta_Predictor.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Meta_Predictor.h"
 
 namespace morpheo {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -37,6 +41,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_transition.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_transition.cpp	(revision 48)
@@ -8,10 +8,14 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Meta_Predictor.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Meta_Predictor.h"
 
 namespace morpheo                    {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -33,6 +37,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_vhdl.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_vhdl.cpp	(revision 48)
@@ -7,11 +7,15 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Meta_Predictor.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Meta_Predictor.h"
 #include "Behavioural/include/Vhdl.h"
 
 namespace morpheo                    {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -38,6 +42,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_vhdl_body.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_vhdl_body.cpp	(revision 48)
@@ -7,10 +7,14 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Meta_Predictor.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Meta_Predictor.h"
 
 namespace morpheo                    {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -24,6 +28,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_vhdl_declaration.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_vhdl_declaration.cpp	(revision 48)
@@ -7,10 +7,14 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Meta_Predictor.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Meta_Predictor.h"
 
 namespace morpheo {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -24,6 +28,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_vhdl_testbench_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_vhdl_testbench_transition.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_vhdl_testbench_transition.cpp	(revision 48)
@@ -7,10 +7,14 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Meta_Predictor.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Meta_Predictor.h"
 
 namespace morpheo                    {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -28,6 +32,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters.cpp	(revision 48)
@@ -6,10 +6,14 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Parameters.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Parameters.h"
 
 namespace morpheo {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -81,5 +85,5 @@
     if (_have_meta_predictor)
       {
-    _param_two_level_branch_predictor_0 = new morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::two_level_branch_predictor::Parameters (_predictor_0_have_bht              ,
+    _param_two_level_branch_predictor_0 = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::two_level_branch_predictor::Parameters (_predictor_0_have_bht              ,
 																		      _predictor_0_bht_size_shifter      ,
 																		      _predictor_0_bht_nb_shifter        ,
@@ -92,5 +96,5 @@
 																		      _nb_branch_complete                );
 
-    _param_two_level_branch_predictor_1 = new morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::two_level_branch_predictor::Parameters (_predictor_1_have_bht              ,
+    _param_two_level_branch_predictor_1 = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::two_level_branch_predictor::Parameters (_predictor_1_have_bht              ,
 																		      _predictor_1_bht_size_shifter      ,
 																		      _predictor_1_bht_nb_shifter        ,
@@ -104,5 +108,5 @@
       }
 
-    _param_two_level_branch_predictor_2 = new morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::two_level_branch_predictor::Parameters (_predictor_2_have_bht              ,
+    _param_two_level_branch_predictor_2 = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::two_level_branch_predictor::Parameters (_predictor_2_have_bht              ,
 																		      _predictor_2_bht_size_shifter      ,
 																		      _predictor_2_bht_nb_shifter        ,
@@ -116,5 +120,5 @@
 
 
-    _param_meta_predictor_glue = new morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::meta_predictor_glue::Parameters (_have_meta_predictor               ,
+    _param_meta_predictor_glue = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::meta_predictor_glue::Parameters (_have_meta_predictor               ,
 																       _predictor_0_have_bht              ,
 																       _predictor_0_bht_size_shifter      ,
@@ -175,5 +179,5 @@
     if (_have_meta_predictor)
       {
-    _param_two_level_branch_predictor_0 = new morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::two_level_branch_predictor::Parameters (_predictor_0_have_bht              ,
+    _param_two_level_branch_predictor_0 = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::two_level_branch_predictor::Parameters (_predictor_0_have_bht              ,
 																		      _predictor_0_bht_size_shifter      ,
 																		      _predictor_0_bht_nb_shifter        ,
@@ -186,5 +190,5 @@
 																		      _nb_branch_complete                );
 
-    _param_two_level_branch_predictor_1 = new morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::two_level_branch_predictor::Parameters (_predictor_1_have_bht              ,
+    _param_two_level_branch_predictor_1 = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::two_level_branch_predictor::Parameters (_predictor_1_have_bht              ,
 																		      _predictor_1_bht_size_shifter      ,
 																		      _predictor_1_bht_nb_shifter        ,
@@ -198,5 +202,5 @@
       }
 
-    _param_two_level_branch_predictor_2 = new morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::two_level_branch_predictor::Parameters (_predictor_2_have_bht              ,
+    _param_two_level_branch_predictor_2 = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::two_level_branch_predictor::Parameters (_predictor_2_have_bht              ,
 																		      _predictor_2_bht_size_shifter      ,
 																		      _predictor_2_bht_nb_shifter        ,
@@ -209,5 +213,5 @@
 																		      _nb_branch_complete                );
     
-    _param_meta_predictor_glue = new morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::meta_predictor_glue::Parameters (_have_meta_predictor               ,
+    _param_meta_predictor_glue = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::meta_predictor_glue::Parameters (_have_meta_predictor               ,
 																       _predictor_0_have_bht              ,
 																       _predictor_0_bht_size_shifter      ,
@@ -245,6 +249,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters_msg_error.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters_msg_error.cpp	(revision 48)
@@ -6,6 +6,6 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Parameters.h"
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Types.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Parameters.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Types.h"
 #include <sstream>
 using namespace std;
@@ -13,6 +13,10 @@
 namespace morpheo                    {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -43,6 +47,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters_print.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters_print.cpp	(revision 48)
@@ -6,5 +6,5 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Parameters.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Parameters.h"
 #include "Behavioural/include/XML.h"
 using namespace std;
@@ -12,6 +12,10 @@
 namespace morpheo                    {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -132,5 +136,5 @@
 
   ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::Parameters & x)
+		       morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::Parameters & x)
   {
     output_stream << x.print(0);
@@ -140,6 +144,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 }; // end namespace behavioural
 }; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Statistics.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Statistics.cpp	(revision 48)
@@ -7,10 +7,14 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Statistics.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Statistics.h"
 
 namespace morpheo                    {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -35,6 +39,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Statistics_add.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Statistics_add.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Statistics_add.cpp	(revision 48)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Statistics.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Statistics.h"
 
 #include <sstream>
@@ -14,6 +14,10 @@
 namespace morpheo                    {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -26,6 +30,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Statistics_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Statistics_print.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Statistics_print.cpp	(revision 48)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Statistics.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Statistics.h"
 
 #include <sstream>
@@ -14,6 +14,10 @@
 namespace morpheo {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -43,5 +47,5 @@
 
   ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::Statistics & x)
+		       morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::Statistics & x)
   {
     output_stream << x.print(0);
@@ -51,6 +55,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Statistics_print_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Statistics_print_body.cpp	(revision 47)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Statistics_print_body.cpp	(revision 48)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Statistics.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Statistics.h"
 
 #include <sstream>
@@ -14,6 +14,10 @@
 namespace morpheo                    {
 namespace behavioural {
-namespace stage_1_ifetch {
-namespace predictor {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+
 namespace meta_predictor {
 
@@ -34,6 +38,11 @@
 
 }; // end namespace meta_predictor
-}; // end namespace predictor
-}; // end namespace stage_1_ifetch
+
+}; // end namespace core
+}; // end namespace multi_front_end
+}; // end namespace front_end
+}; // end namespace prediction_unit
+}; // end namespace direction
+
 
 }; // end namespace behavioural