Index: trunk/Makefile.x86
===================================================================
--- trunk/Makefile.x86	(revision 47)
+++ trunk/Makefile.x86	(revision 51)
@@ -194,5 +194,5 @@
                  -Itools/arch_info       \
                  -Ihal/generic           \
-                 -Ihal/x86_64            \
+                 -Ihal/x86_64/core       \
                  -I.
 
@@ -277,5 +277,5 @@
                                 kernel/drivers/soclib/%.h   \
                                 kernel_config.h             \
-                                hal/x86_64/hal_types.h
+                                hal/x86_64/core/hal_types.h
 	$(CC) $(KERNEL_INCLUDE) $(CFLAGS)  -c -o $@ $<
 	$(DU) -D $@ > $@.txt
@@ -286,5 +286,5 @@
                                 kernel/kern/%.h             \
                                 kernel_config.h             \
-                                hal/x86_64/hal_types.h
+                                hal/x86_64/core/hal_types.h
 	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
 	$(DU) -D $@ > $@.txt
@@ -292,73 +292,73 @@
 ######################################
 # Rules to generate kernel/hal objects
-build/kernel/hal/%.o:           hal/x86_64/%.c         \
+build/kernel/hal/%.o:           hal/x86_64/core/%.c         \
                                 hal/generic/%.h             \
                                 kernel_config.h             \
-                                hal/x86_64/hal_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-	$(DU) -D $@ > $@.txt
-
-build/kernel/hal/hal_boot.o:    hal/x86_64/hal_boot.S \
-                                hal/x86_64/hal_boot.h        \
-                                hal/x86_64/hal_multiboot.h   \
-                                hal/x86_64/hal_segmentation.h \
-                                kernel_config.h              \
-                                hal/x86_64/hal_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-	$(DU) -D $@ > $@.txt
-
-build/kernel/hal/hal_init.o:    hal/x86_64/hal_init.c         \
-                                hal/x86_64/hal_boot.h         \
-                                hal/x86_64/hal_multiboot.h    \
-                                hal/x86_64/hal_segmentation.h \
-                                hal/x86_64/hal_acpi.h         \
-                                hal/x86_64/hal_lapic.h        \
-                                hal/x86_64/hal_internal.h     \
+                                hal/x86_64/core/hal_types.h
+	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
+	$(DU) -D $@ > $@.txt
+
+build/kernel/hal/hal_boot.o:    hal/x86_64/core/hal_boot.S \
+                                hal/x86_64/core/hal_boot.h        \
+                                hal/x86_64/core/hal_multiboot.h   \
+                                hal/x86_64/core/hal_segmentation.h \
+                                kernel_config.h              \
+                                hal/x86_64/core/hal_types.h
+	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
+	$(DU) -D $@ > $@.txt
+
+build/kernel/hal/hal_init.o:    hal/x86_64/core/hal_init.c         \
+                                hal/x86_64/core/hal_boot.h         \
+                                hal/x86_64/core/hal_multiboot.h    \
+                                hal/x86_64/core/hal_segmentation.h \
+                                hal/x86_64/core/hal_acpi.h         \
+                                hal/x86_64/core/hal_lapic.h        \
+                                hal/x86_64/core/hal_internal.h     \
                                 kernel_config.h               \
-                                hal/x86_64/hal_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-	$(DU) -D $@ > $@.txt
-
-build/kernel/hal/hal_cpu.o:     hal/x86_64/hal_cpu.S \
-                                hal/x86_64/hal_boot.h        \
-                                hal/x86_64/hal_segmentation.h \
-                                kernel_config.h              \
-                                hal/x86_64/hal_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-	$(DU) -D $@ > $@.txt
-
-build/kernel/hal/hal_trap.o:    hal/x86_64/hal_trap.c \
-                                hal/x86_64/hal_boot.h        \
-                                hal/x86_64/hal_segmentation.h \
-                                kernel_config.h              \
-                                hal/x86_64/hal_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-	$(DU) -D $@ > $@.txt
-
-build/kernel/hal/hal_kentry.o:  hal/x86_64/hal_kentry.S      \
-                                hal/x86_64/hal_kentry.h      \
-                                hal/x86_64/hal_boot.h        \
-                                kernel_config.h              \
-                                hal/x86_64/hal_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-	$(DU) -D $@ > $@.txt
-
-build/kernel/hal/hal_acpi.o:    hal/x86_64/hal_acpi.c        \
-                                hal/x86_64/hal_acpi.h        \
-                                kernel_config.h              \
-                                hal/x86_64/hal_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-	$(DU) -D $@ > $@.txt
-
-build/kernel/hal/hal_lapic.o:   hal/x86_64/hal_lapic.c       \
-                                hal/x86_64/hal_lapic.h       \
-                                kernel_config.h              \
-                                hal/x86_64/hal_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-	$(DU) -D $@ > $@.txt
-
-build/kernel/hal/x86_printf.o:  hal/x86_64/x86_printf.c      \
-                                kernel_config.h              \
-                                hal/x86_64/hal_types.h
+                                hal/x86_64/core/hal_types.h
+	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
+	$(DU) -D $@ > $@.txt
+
+build/kernel/hal/hal_cpu.o:     hal/x86_64/core/hal_cpu.S \
+                                hal/x86_64/core/hal_boot.h        \
+                                hal/x86_64/core/hal_segmentation.h \
+                                kernel_config.h              \
+                                hal/x86_64/core/hal_types.h
+	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
+	$(DU) -D $@ > $@.txt
+
+build/kernel/hal/hal_trap.o:    hal/x86_64/core/hal_trap.c \
+                                hal/x86_64/core/hal_boot.h        \
+                                hal/x86_64/core/hal_segmentation.h \
+                                kernel_config.h              \
+                                hal/x86_64/core/hal_types.h
+	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
+	$(DU) -D $@ > $@.txt
+
+build/kernel/hal/hal_kentry.o:  hal/x86_64/core/hal_kentry.S      \
+                                hal/x86_64/core/hal_kentry.h      \
+                                hal/x86_64/core/hal_boot.h        \
+                                kernel_config.h              \
+                                hal/x86_64/core/hal_types.h
+	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
+	$(DU) -D $@ > $@.txt
+
+build/kernel/hal/hal_acpi.o:    hal/x86_64/core/hal_acpi.c        \
+                                hal/x86_64/core/hal_acpi.h        \
+                                kernel_config.h              \
+                                hal/x86_64/core/hal_types.h
+	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
+	$(DU) -D $@ > $@.txt
+
+build/kernel/hal/hal_lapic.o:   hal/x86_64/core/hal_lapic.c       \
+                                hal/x86_64/core/hal_lapic.h       \
+                                kernel_config.h              \
+                                hal/x86_64/core/hal_types.h
+	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
+	$(DU) -D $@ > $@.txt
+
+build/kernel/hal/x86_printf.o:  hal/x86_64/core/x86_printf.c      \
+                                kernel_config.h              \
+                                hal/x86_64/core/hal_types.h
 	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
 	$(DU) -D $@ > $@.txt
@@ -369,5 +369,5 @@
                                 kernel/devices/%.h          \
                                 kernel_config.h             \
-                                hal/x86_64/hal_types.h
+                                hal/x86_64/core/hal_types.h
 	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
 	$(DU) -D $@ > $@.txt
@@ -378,5 +378,5 @@
                                 kernel/mm/%.h               \
                                 kernel_config.h             \
-                                hal/x86_64/hal_types.h
+                                hal/x86_64/core/hal_types.h
 	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
 	$(DU) -D $@ > $@.txt
@@ -387,5 +387,5 @@
                                 kernel/libk/%.h             \
                                 kernel_config.h             \
-                                hal/x86_64/hal_types.h
+                                hal/x86_64/core/hal_types.h
 	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
 	$(DU) -D $@ > $@.txt
@@ -396,5 +396,5 @@
                                 kernel/syscalls/syscalls.h  \
                                 kernel_config.h             \
-                                hal/x86_64/hal_types.h
+                                hal/x86_64/core/hal_types.h
 	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
 	$(DU) -D $@ > $@.txt
@@ -405,5 +405,5 @@
                                 kernel/vfs/%.h              \
                                 kernel_config.h             \
-                                hal/x86_64/hal_types.h
+                                hal/x86_64/core/hal_types.h
 	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
 	$(DU) -D $@ > $@.txt